﻿#!/usr/bin/perl -w
use strict;
my @langs     = (  "en","es","ja" );
my @files     = ('{l}lang.xml');
my %resEtalon = ();
my %textEtalon = ();

my $f = $files[0];
$f =~ s/\{l\}/\_ru\_/;
LoadTextFile(\%textEtalon, $f);

open (ERROR_FILE,">errors.txt");
CheckAllTexts();
close (ERROR_FILE);
system("errors.txt");
unlink("errors.txt");

sub CheckAllTexts {
	foreach(@langs) {
		my %resHash = ();
		my $file = $files[0];
		$file =~ s/\{l\}/\_$_\_/;
		LoadTextFile(\%resHash, $file);
		CheckResHash( \%textEtalon, \%resHash, $file);
		#проверка все ли из файла есть в эталоне
		CheckResHash (\%resHash, \%textEtalon, $file);
	}
}

sub  CheckResHash {
	my $etalon     = shift();
	my $items	= shift();
	my $checkFile = shift();
	foreach (keys %$etalon) {
		if (!defined($$items{$_})) {
			print ERROR_FILE "ERROR dont find $_ in $checkFile\n";
		}
	}	
}

sub CheckExsistsFiles {
	my $path = shift();
	my $check  = shift();
	my %errors = ();
	foreach (keys %$check) {
		my $f = $path.$$check{$_};
		#$f =~ tr/\//\\/;
		if (not -e $f) {
			$errors{$f} = 1;
			#print qq(<tr><td>Файл $f не существует.</td></tr>);
		}
	}
	
	foreach (sort keys %errors) {
		print ERROR_FILE qq(ERROR file $_ not exists\n);
	}
}


sub LoadTextFile {
	my $items     = shift();
	%$items = ();
	my $checkFile = shift();
	open( FILE, $checkFile ) or die "Cant open file $checkFile $!";;
	my $prefixGroup = "";
	my $pathPrefix  = "";
	my @f           = <FILE>;
	my $l           = join( '', @f );
	$l =~ tr/\n\r/  /;
	$l =~ s/\<\!--.*?--\>//mg;

	@f = ();
	while ( ( $l =~ s/\<(.*?)\>// ) ) {
		push( @f, "\<$1\>" );
	}
	foreach (sort @f) {
		my $line = $_;

		if ( $line =~ /\<Item / ) {
			my $id      = "";
			if ( $line =~ /id\=[\"\'](\d+)[\"\']/ ) {
				$id = $1;
			}
			if ( defined( $$items{$id } ) ) {
				print ERROR_FILE "ERROR Text $id  defined in  $checkFile more than once\n";
			} else {
				$$items{ $id } = 1;
			}
		}
	}
	close(FILE);
}
